Package org.apache.sis.referencing.crs

# Class DefaultParametricCRS

Object
FormattableObject
AbstractIdentifiedObject
AbstractReferenceSystem
AbstractCRS
DefaultParametricCRS

All Implemented Interfaces:
  `Serializable`, `Formattable`, `Deprecable`, `LenientComparable`, `CoordinateReferenceSystem`, `SingleCRS`, `IdentifiedObject`, `ReferenceSystem`

public class DefaultParametricCRS extends AbstractCRS
A 1-dimensional coordinate reference system which uses parameter values or functions. Parametric CRS can be used for physical properties or functions that vary monotonically with height. A typical example is the pressure in meteorological applications.

Used with datum type: Parametric.
Used with coordinate system type: Parametric.

## Immutability and thread safety

This class is immutable and thus thread-safe if the property values (not necessarily the map itself), the coordinate system and the datum instances given to the constructor are also immutable. Unless otherwise noted in the javadoc, this condition holds if all components were created using only SIS factories and static constants.

Since:
  0.7
See Also:
  - `DefaultParametricDatum`
  - `DefaultParametricCS`
  - `GeodeticAuthorityFactory​.createParametricCRS(String)`
  - Serialized Form

Defined in the `sis-referencing` module

- ## Field Summary

  ### Fields inherited from class AbstractIdentifiedObject

  `DEPRECATED_KEY, LOCALE_KEY`

  ### Fields inherited from interface IdentifiedObject

  `ALIAS_KEY, IDENTIFIERS_KEY, NAME_KEY, REMARKS_KEY`

  ### Fields inherited from interface ReferenceSystem

  `DOMAIN_OF_VALIDITY_KEY, SCOPE_KEY`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  ``
  `DefaultParametricCRS(Map<String,?> properties, DefaultParametricDatum datum, DefaultParametricCS cs)`
  Creates a coordinate reference system from the given properties, datum and coordinate system.
  `protected`
  `DefaultParametricCRS(DefaultParametricCRS crs)`
  Constructs a new coordinate reference system with the same values than the specified one.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `DefaultParametricCRS`
  `forConvention(AxesConvention convention)`
  Returns a coordinate reference system equivalent to this one but with axes rearranged according the given convention.
  `protected String`
  `formatTo(Formatter formatter)`
  Formats this CRS as a Well Known Text `ParametricCRS[…]` element.
  `DefaultParametricCS`
  `getCoordinateSystem()`
  Returns the coordinate system.
  `DefaultParametricDatum`
  `getDatum()`
  Returns the datum.

  ### Methods inherited from class AbstractCRS

  `castOrCopy, computeHashCode, equals, getInterface`

  ### Methods inherited from class AbstractReferenceSystem

  `getDomainOfValidity, getScope`

  ### Methods inherited from class AbstractIdentifiedObject

  `castOrCopy, equals, formatTo, getAlias, getDescription, getIdentifiers, getName, getRemarks, hashCode, isDeprecated, isHeuristicMatchForName`

  ### Methods inherited from class FormattableObject

  `print, toString, toString, toWKT`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface IdentifiedObject

  `getAlias, getIdentifiers, getName, getRemarks, toWKT`

  ### Methods inherited from interface ReferenceSystem

  `getDomainOfValidity, getScope`

- ## Constructor Details

  - ### DefaultParametricCRS

    public DefaultParametricCRS(Map<String,?> properties, DefaultParametricDatum datum, DefaultParametricCS cs)
    Creates a coordinate reference system from the given properties, datum and coordinate system. The properties given in argument follow the same rules than for the super-class constructor. The following table is a reminder of main (not all) properties:

    Recognized properties (non exhaustive list)
    Property name | Value type | Returned by
    --- | --- | ---
    "name" | `Identifier` or `String` | `AbstractIdentifiedObject.getName()`
    "alias" | `GenericName` or `CharSequence` (optionally as array) | `AbstractIdentifiedObject.getAlias()`
    "identifiers" | `Identifier` (optionally as array) | `AbstractIdentifiedObject.getIdentifiers()`
    "remarks" | `InternationalString` or `String` | `AbstractIdentifiedObject.getRemarks()`
    "domainOfValidity" | `Extent` | `AbstractReferenceSystem.getDomainOfValidity()`
    "scope" | `InternationalString` or `String` | `AbstractReferenceSystem.getScope()`

    Warning: in a future SIS version, the parameter types may be changed to `org​.opengis​.referencing​.datum​.ParametricDatum` and `org​.opengis​.referencing​.cs​.ParametricCS` Those change are pending GeoAPI revision.
    Parameters:
      `properties` - the properties to be given to the coordinate reference system.
      `datum` - the datum.
      `cs` - the coordinate system.

  - ### DefaultParametricCRS

    protected DefaultParametricCRS(DefaultParametricCRS crs)
    Constructs a new coordinate reference system with the same values than the specified one. This copy constructor provides a way to convert an arbitrary implementation into a SIS one or a user-defined one (as a subclass), usually in order to leverage some implementation-specific API.

    This constructor performs a shallow copy, i.e. the properties are not cloned.

    Warning: in a future SIS version, the parameter type may be changed to `org​.opengis​.referencing​.crs​.ParametricCRS`. This change is pending GeoAPI revision.
    Parameters:
      `crs` - the coordinate reference system to copy.

- ## Method Details

  - ### getDatum

    public DefaultParametricDatum getDatum()
    Returns the datum.
    Specified by:
      `getDatum` in interface `SingleCRS`
    Returns:
      the datum.

  - ### getCoordinateSystem

    public DefaultParametricCS getCoordinateSystem()
    Returns the coordinate system.
    Specified by:
      `getCoordinateSystem` in interface `CoordinateReferenceSystem`
    Specified by:
      `getCoordinateSystem` in interface `SingleCRS`
    Overrides:
      `getCoordinateSystem` in class `AbstractCRS`
    Returns:
      the coordinate system.

  - ### forConvention

    public DefaultParametricCRS forConvention(AxesConvention convention)
    Returns a coordinate reference system equivalent to this one but with axes rearranged according the given convention. If this CRS is already compatible with the given convention, then this method returns `this`.
    Overrides:
      `forConvention` in class `AbstractCRS`
    Parameters:
      `convention` - the axes convention for which a coordinate reference system is desired.
    Returns:
      a coordinate reference system compatible with the given convention (may be `this`).
    See Also:
      - `AbstractCS​.forConvention(AxesConvention)`

  - ### formatTo

    protected String formatTo(Formatter formatter)
    Formats this CRS as a Well Known Text `ParametricCRS[…]` element.
    Compatibility note: `ParametricCRS` is defined in the WKT 2 specification only.
    Overrides:
      `formatTo` in class `AbstractCRS`
    Parameters:
      `formatter` - the formatter where to format the inner content of this WKT element.
    Returns:
      `"ParametricCRS"`.
    See Also:
      - WKT 2 specification